#ifndef CURVEVIEW_H
#define CURVEVIEW_H

#include <BeBuild.h>

class CurveView : public BView
{
	public:
		CurveView(BRect frame, const char *name, const char *label,	BMessage *message,
					uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP,
					uint32 flags = B_WILL_DRAW | B_NAVIGABLE); 

		typedef BControl		inherited;

virtual void 		AttachedToWindow(void);
virtual void 		Draw(BRect updateRect);
virtual void 		GetPreferredSize(float *width, float *height);
virtual	void 		FrameResized(float new_width, float new_height);
virtual void 		KeyDown(const char *bytes, int32 numBytes);
virtual void 		MouseDown(BPoint point);
virtual void 		MouseUp(BPoint point);
virtual void 		MouseMoved(BPoint point, uint32 transit, const BMessage *message);
virtual void 		MessageReceived(BMessage *message);

virtual void		WindowActivated(bool active);
virtual	void		KeyDown(const char *bytes, int32 numBytes);
virtual	void		MouseUp(BPoint point);
virtual	void		MouseMoved(BPoint point, uint32 transit, const BMessage *message);
virtual	void		DetachedFromWindow();
virtual	void		SetValue(int32 value);
virtual void		GetPreferredSize(float *width, float *height);
virtual void		ResizeToPreferred();
virtual	status_t	Invoke(BMessage *message = NULL);
virtual	void		FrameMoved(BPoint newLocation);
virtual	void		FrameResized(float width, float height);

virtual BHandler	*ResolveSpecifier(BMessage *message,
									int32 index,
									BMessage *specifier,
									int32 what,
									const char *property);
virtual status_t	GetSupportedSuites(BMessage *message);

virtual void		MakeFocus(bool focused = true);
virtual void		AllAttached();
virtual void		AllDetached();

virtual status_t	Perform(perform_code d, void *arg);

private:

virtual	void		_ReservedCheckBox1();
virtual	void		_ReservedCheckBox2();
virtual	void		_ReservedCheckBox3();

		BCheckBox	&operator=(const BCheckBox &);

		bool		fOutlined;
		uint32		_reserved[2];
};
//------------------------------------------------------------------------------

#endif // _CHECK_BOX_H

/*
 * $Log $
 *
 * $Id  $
 *
 */
