// *** LICENSE ***
// This file is Copyright (c) 2001 Marcus Overhagen
//
// It is being made publicly available and free to use
// in freeware, shareware or commercial products.
// 
// If you use this software or parts of it in your 
// own product, you are required to state in your 
// documentation and about box or copyright notice 
// that portions of your sofware were developed
// by Marcus Overhagen.
//
// This software is provided 'as-is', without any 
// express or implied warranty. In no event will 
// the author be held liable for any damages (direct,
// indirect or otherwise) arising from the use of
// this software. In the case of states in which 
// such disclaimers do not apply, the author hereby
// limits his liability in such matters to USD $1. 

#ifndef SPLITTER_VIEW_H
#define SPLITTER_VIEW_H

class BCursor;

class CSplitterView : public BView {
public:
	CSplitterView(BRect frame, const char *name, BView *left, BView *right, uint32 resizingMode, uint32 flags);
	~CSplitterView();
	void MakeFocus(bool focused = true);
	void SetPercent(float percent);
	float Percent();
	
protected:
	void FrameResized(float width, float height);
	void MouseDown(BPoint p);
	void MouseMoved(BPoint p, uint32 transit, const BMessage *message);
	void MouseUp(BPoint p);
	void DoMouse(float x);
	void AllAttached();

	BView		*viewLeft;
	BView		*viewRight;
	float		fPercent;
	bool 		bIsTracking;
	bool 		bHasTrackingCursor;
	enum { X_BAR_SIZE = 6};

	BCursor *cursor;
};

#endif