#include <string.h>
#include <StorageKit.h>
#include "libsane_beos.h"

int beos_get_next_addon
	(
	char *	addon_name,
	int		addon_name_length,
	void **	cookie
	)
{
    entry_ref 		ref;
	BDirectory *	dir;
 	
	if ( *cookie == NULL )
		{
		// first call, get a BDirectory on SANE addon directory
		BPath	path;

		if ( find_directory(B_USER_ADDONS_DIRECTORY, &path) != B_OK )
			return 0;
		
		path.Append("SANE");
		dir = new BDirectory(path.Path());
		if ( dir->InitCheck() != B_OK )
			{
			// Houston, we got a problem: no SANE user addons sub directory...
			delete dir;
			return 0;
			};
			
		*cookie = dir;
		}
	else
		dir = (BDirectory *) *cookie;
	
	if ( dir == NULL )
		return 0;
		
	while ( dir->GetNextRef(&ref) == B_OK )
		{
		BNode 		node;
    	BNodeInfo 	ni;
    	char 		mime_type[B_MIME_TYPE_LENGTH];

		node.SetTo(&ref);
		ni.SetTo(&node);
		ni.GetType(mime_type);
		ni.SetTo(NULL);

		if (strstr(mime_type, "executable") == NULL)
    	    continue;	//all add-on's should have an executable mimetype !
	
		// we got a new SANE valid addon
		strncpy(addon_name, ref.name, addon_name_length);
		return 1;
		};

	// no more entry in the SANE addons directory
	delete dir;
	return 0;
}


